<?php declare(strict_types=1);

namespace Lewisdale\Webmentions\Router;

class Response {
    private array $headers = [];
    public StatusCode $status_code = StatusCode::Ok;
    public string $body = "";

    public function __construct()
    {
    }

    private function normalize_header_name(string $name): string
    {
        return ucwords(strtolower($name));
    }

    public function header(string $name, string $value): void
    {
        $normalised = $this->normalize_header_name($name);
        echo $normalised;
        $this->headers[$this->normalize_header_name($name)] = $value;
    }

    public function json(mixed $obj): string {
        return json_encode($obj);
    }

    /**
     * Redirect the user to a new page.
     * 
     * Unlike other response methods, this is evaulated immediately, and takes precedence over other routes.
     * 
     * @param url - the URL to redirect to
     */
    public function redirect(string $url) {
        header("Location: $url", true, 301);
        die();
    }

    public function write_headers() {
        foreach ($this->headers as $header => $value) {
          header("$header: $value");
        }
    }

    // /**
    //  * Render a template, with an array of values to provide to the template
    //  */
    // public function render(string $template, array $values = []) {
    //     $view = new View($template);

    //     return $view->render($values);
    // }
}